import com.haxepunk.HXP;
import com.haxepunk.Entity;
import com.haxepunk.graphics.Stamp;
import com.haxepunk.utils.Draw;
import flash.display.BitmapData;


class EnergyLink {
	public function new(a:Building, b:Building) {
		this.a = a;
		this.b = b;
	}
	public var a:Building;
	public var b:Building;
}

class EnergyGrid extends Entity {
	public var links:Array<EnergyLink> = [];
	public var bitmap: BitmapData;

	public function new() {
		super();
		bitmap = new BitmapData(HXP.width, HXP.height, true, 0x00);
		graphic = new Stamp(bitmap);
	}


	public function addLink(a:Building, b:Building) {
		var link:EnergyLink = new EnergyLink(a, b);
		links.push(link);
		drawLink(link);
	}

	public function remove(b:Building) {
		var rm:Array<EnergyLink> = [];
		for(l in links) if(l.a==b || l.b==b) rm.push(l);
		for(r in rm) links.remove(r);
		redraw();
	}

	public function isLinked(b:Building) {
		for(l in links) if(l.a==b || l.b==b) return true;
		return false;
	}

	public function drawLink(l:EnergyLink) {
		// Ideally use a bezier curve - just draw a line for now
		Draw.setTarget(bitmap);
		Draw.linePlus(Std.int(l.a.x), Std.int(l.a.y), Std.int(l.b.x), Std.int(l.b.y), 0x00, 0.1, 1.5);
		Draw.resetTarget();
	}

	public function redraw() {
		bitmap.fillRect(HXP.bounds, 0x0);
		for(l in links) drawLink(l);
	}
	
}

