import com.haxepunk.HXP;
import com.haxepunk.Scene;
import Building;
import Units;

class Level extends Scene {

	public var buildings:Array<Building> = [];
	public var grid: EnergyGrid;
	public var menu: Menu;
	public var countdown: Int = 800;
	public var wave: Int = 1;
	public var back: Base;
	
	public override function begin() {
		back = new Base();
		add(back);

		menu = new Menu();
		menu.addBuilding( new Generator(0,0) );
		menu.addBuilding( new PowerNode(0,0) );
		menu.addBuilding( new Extractor(0,0) );
		menu.addBuilding( new Radar(0,0) );
		menu.addBuilding( new TurretBuilding(0,0) );
		add(menu);

		grid = new EnergyGrid();
		add(grid);
	}

	public override function update() {
		super.update();

		// Spawn wave
		if(--countdown<0) {
			countdown = Std.int(Math.max(200, 1500 - wave*4));
			HXP.angleXY(HXP.point, HXP.random*360, 2000 + HXP.random*800, HXP.halfWidth, HXP.halfHeight);
			var nx:Float = HXP.point.x / HXP.point.length;
			var ny:Float = HXP.point.y / HXP.point.length;
			for(i in 0...3+wave) {
				var o:Unit = new Tank(HXP.point.x + ny*(i-wave/2)*40, HXP.point.y - nx*(i-wave/2)*40);
				add(o);
			}
			if(wave<20) ++wave;
		}
	}
}

